package cn.cecep.talroad.service;

import cn.cecep.talroad.domain.MonDevReal;
import cn.cecep.talroad.vo.MonDevGtRealVO;
import cn.cecep.talroad.vo.analysis.AvgValueVo;
import cn.hutool.core.date.DateTime;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.Date;
import java.util.List;

/**
 * 设备数据(有组织)-实时 保存有组织设备的实时数据。p1~pn字段对应各设备的生产过程类参数Service接口
 *
 * @author szhpt
 * @date 2023-01-10*/
public interface IMonDevRealService extends  IService<MonDevReal>
{
    /**
     * 查询设备数据(有组织)-实时 保存有组织设备的实时数据。p1~pn字段对应各设备的生产过程类参数列表
     *
     * @param monDevReal 设备数据(有组织)-实时 保存有组织设备的实时数据。p1~pn字段对应各设备的生产过程类参数
     * @return 设备数据(有组织)-实时 保存有组织设备的实时数据。p1~pn字段对应各设备的生产过程类参数集合
     */
    public List<MonDevReal> selectMonDevRealList(MonDevReal monDevReal);

    List<MonDevGtRealVO> getDataPage(String factoryId, List<String> deviceIds, String startTime, String endTime, String orderField, String orderType, Page page);

    /**
     * 根据设备ID查询最新一条监测数据
     * @param industry
     * @param deviceType
     * @param startDate
     * @return
     */
    public List<MonDevReal> selectLatestByCondition(String industry,String deviceType, Date startDate,Date currDate);

    List<MonDevReal> selectLatestByParam(String industry, String deviceType, Date lastHour,Date currDate);

    List<MonDevReal> selectLastHourData(MonDevReal real);

    List<MonDevReal> selectLastHourDataOne(MonDevReal real);

    List<AvgValueVo> selectAvgTempByParams(Date lastHourBegin, Date lastHourEnd);

    List<AvgValueVo> selectAvgPressByParams(Date lastHourBegin, Date lastHourEnd);

    List<MonDevReal> selectLatestMqgwByParam(String industry, String deviceType, Date lastHour, Date curr);

    List<AvgValueVo> selectLastDayData(DateTime queryBeginTime, DateTime queryEndTime);
}
